﻿using System;
using System.Diagnostics;
using TimeSnapperPluginAPI;
namespace CSharpSamplePlugin
{
    public class AnotherPluginSample : ITimeSnapperPlugin
    {
        bool ITimeSnapperPlugin.Configurable
        {
            get { return false; }
        }

        void ITimeSnapperPlugin.Configure()
        {
            throw new NotImplementedException();
        }

        string ITimeSnapperPlugin.Description
        {
            get { return "Another sample plugin."; }
        }

        string ITimeSnapperPlugin.FriendlyName
        {
            get { return "Another"; }
        }

        object ITimeSnapperPlugin.HandleEvent(TimeSnapperEvent TimeSnapperEvent, EventArgs args)
        {
            switch (TimeSnapperEvent)
            {
                case TimeSnapperEvent.FlagSaved:
                    {
                        var specificArgs = (TimeSnapperPluginAPI.FlagSavedEventArgs)args;                        
                        Debug.WriteLine("A flag of type " + specificArgs.Flag.FlagType.ToString() + " was saved");
                    }
                    break;
                case TimeSnapperEvent.SnapshotSaved:
                    Debug.WriteLine("A snapshot was saved");
                    break;
                default:
                    Debug.Assert(false, "Hey! I didn't subscribe to " +
                        TimeSnapperEvent.ToString() + "... why am I being notified?");
                    break;
            }
            return null;
        }

        TimeSnapperMenuItem[] ITimeSnapperPlugin.MenuItems()
        {
            return null;
        }

        Guid ITimeSnapperPlugin.PluginID
        {
            get { return new Guid("FB2D3C48-ECD1-4826-AF9D-4658871F9934"); }
        }

        TimeSnapperEvent[] ITimeSnapperPlugin.SubscribesTo()
        {
            return new TimeSnapperEvent[] { TimeSnapperEvent.FlagSaved, 
                                            TimeSnapperEvent.SnapshotSaved };
        }
    }
}
